Index: trunk/lib/FlairCore/src/Vector2D.h
===================================================================
--- trunk/lib/FlairCore/src/Vector2D.h	(revision 14)
+++ trunk/lib/FlairCore/src/Vector2D.h	(revision 15)
@@ -14,153 +14,153 @@
 #define VECTOR2D_H
 
-namespace flair { namespace core {
+namespace flair {
+namespace core {
 
-    /*! \class Vector2D
-    *
-    * \brief Class defining a 2D vector
-    */
-    class Vector2D {
-        public:
-            /*!
-            * \brief Constructor
-            *
-            * Construct a Vector2D using specified values.
-            *
-            * \param x
-            * \param y
-            */
-            Vector2D(float x=0,float y=0);
+/*! \class Vector2D
+*
+* \brief Class defining a 2D vector
+*/
+class Vector2D {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a Vector2D using specified values.
+  *
+  * \param x
+  * \param y
+  */
+  Vector2D(float x = 0, float y = 0);
 
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~Vector2D();
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~Vector2D();
 
-            /*!
-            * \brief Rotation
-            *
-            * \param value rotation value in radians
-            */
-            void Rotate(float value);
+  /*!
+  * \brief Rotation
+  *
+  * \param value rotation value in radians
+  */
+  void Rotate(float value);
 
-            /*!
-            * \brief Rotation
-            *
-            * \param value rotation value in degrees
-            */
-            void RotateDeg(float value);
+  /*!
+  * \brief Rotation
+  *
+  * \param value rotation value in degrees
+  */
+  void RotateDeg(float value);
 
-            /*!
-            * \brief Norm
-            *
-            * \return value
-            */
-            float GetNorm(void) const;
+  /*!
+  * \brief Norm
+  *
+  * \return value
+  */
+  float GetNorm(void) const;
 
-            /*!
-            * \brief Normalize
-            */
-            void Normalize(void);
+  /*!
+  * \brief Normalize
+  */
+  void Normalize(void);
 
-            /*!
-            * \brief Saturate
-            *
-            * Saturate between min and max
-            *
-            * \param min minimum Vector2D value
-            * \param max maximum Vector2D value
-            */
-            void Saturate(Vector2D min,Vector2D max);
+  /*!
+  * \brief Saturate
+  *
+  * Saturate between min and max
+  *
+  * \param min minimum Vector2D value
+  * \param max maximum Vector2D value
+  */
+  void Saturate(Vector2D min, Vector2D max);
 
-            /*!
-            * \brief Saturate
-            *
-            * Saturate between min and max
-            *
-            * \param min minimum Vector2D(min,min) value
-            * \param max maximum Vector2D(max,max) value
-            */
-            void Saturate(float min,float max);
+  /*!
+  * \brief Saturate
+  *
+  * Saturate between min and max
+  *
+  * \param min minimum Vector2D(min,min) value
+  * \param max maximum Vector2D(max,max) value
+  */
+  void Saturate(float min, float max);
 
-            /*!
-            * \brief Saturate
-            *
-            * Saturate between -abs(value) and abs(value)
-            *
-            * \param value saturation Vector2D value
-            */
-            void Saturate(const Vector2D &value);
+  /*!
+  * \brief Saturate
+  *
+  * Saturate between -abs(value) and abs(value)
+  *
+  * \param value saturation Vector2D value
+  */
+  void Saturate(const Vector2D &value);
 
-            /*!
-            * \brief Saturate
-            *
-            * Saturate between -abs(Vector2D(value,value)) and abs(Vector2D(value,value))
-            *
-            * \param value saturation Vector2D(value,value)
-            */
-            void Saturate(float value);
+  /*!
+  * \brief Saturate
+  *
+  * Saturate between -abs(Vector2D(value,value)) and abs(Vector2D(value,value))
+  *
+  * \param value saturation Vector2D(value,value)
+  */
+  void Saturate(float value);
 
+  /*!
+  * \brief x
+  */
+  float x;
 
-            /*!
-            * \brief x
-            */
-            float x;
+  /*!
+  * \brief y
+  */
+  float y;
 
-            /*!
-            * \brief y
-            */
-            float y;
+  Vector2D &operator=(const Vector2D &vector);
+};
 
-            Vector2D &operator=(const Vector2D &vector);
-    };
+/*! Add
+*
+* \brief Add
+*
+* \param vectorA vector
+* \param vectorB vector
+*/
+Vector2D operator+(const Vector2D &vectorA, const Vector2D &vectorB);
 
-    /*! Add
-    *
-    * \brief Add
-    *
-    * \param vectorA vector
-    * \param vectorB vector
-    */
-    Vector2D operator + (const Vector2D &vectorA,const Vector2D &vectorB);
+/*! Substract
+*
+* \brief Substract
+*
+* \param vectorA vector
+* \param vectorB vector
+*/
+Vector2D operator-(const Vector2D &vectorA, const Vector2D &vectorB);
 
-    /*! Substract
-    *
-    * \brief Substract
-    *
-    * \param vectorA vector
-    * \param vectorB vector
-    */
-    Vector2D operator - (const Vector2D &vectorA,const Vector2D &vectorB);
+/*! Divid
+*
+* \brief Divid
+*
+* \param vector vector
+* \param coeff coefficent
+* \return vector/coefficient
+*/
+Vector2D operator/(const Vector2D &vector, float coeff);
 
-    /*! Divid
-    *
-    * \brief Divid
-    *
-    * \param vector vector
-    * \param coeff coefficent
-    * \return vector/coefficient
-    */
-    Vector2D operator / (const Vector2D &vector, float coeff);
+/*! Multiply
+*
+* \brief Multiplyf
+*
+* \param vector vector
+* \param coeff coefficent
+* \return coefficient*vector
+*/
+Vector2D operator*(const Vector2D &vector, float coeff);
 
-    /*! Multiply
-    *
-    * \brief Multiplyf
-    *
-    * \param vector vector
-    * \param coeff coefficent
-    * \return coefficient*vector
-    */
-    Vector2D operator * (const Vector2D &vector, float coeff);
-
-    /*! Multiply
-    *
-    * \brief Multiply
-    *
-    * \param coeff coefficent
-    * \param vector vector
-    * \return coefficient*vector
-    */
-    Vector2D operator * (float coeff,const Vector2D &vector);
+/*! Multiply
+*
+* \brief Multiply
+*
+* \param coeff coefficent
+* \param vector vector
+* \return coefficient*vector
+*/
+Vector2D operator*(float coeff, const Vector2D &vector);
 
 } // end namespace core
Index: trunk/lib/FlairCore/src/Vector3D.cpp
===================================================================
--- trunk/lib/FlairCore/src/Vector3D.cpp	(revision 14)
+++ trunk/lib/FlairCore/src/Vector3D.cpp	(revision 15)
@@ -25,12 +25,10 @@
 //#include "Vector3DSpinBox.h"
 
-namespace flair { namespace core {
-
-Vector3D::Vector3D(float inX,float inY,float inZ): x(inX),y(inY),z(inZ){
-}
-
-Vector3D::~Vector3D() {
-
-}
+namespace flair {
+namespace core {
+
+Vector3D::Vector3D(float inX, float inY, float inZ) : x(inX), y(inY), z(inZ) {}
+
+Vector3D::~Vector3D() {}
 /*
 void Vector3D::operator=(const gui::Vector3DSpinBox *vector) {
@@ -42,208 +40,197 @@
 
 Vector3D &Vector3D::operator=(const Vector3D &vector) {
-    x=vector.x;
-    y=vector.y;
-    z=vector.z;
-    return (*this);
+  x = vector.x;
+  y = vector.y;
+  z = vector.z;
+  return (*this);
 }
 
 Vector3D &Vector3D::operator+=(const Vector3D &vector) {
-    x+=vector.x;
-    y+=vector.y;
-    z+=vector.z;
-    return (*this);
+  x += vector.x;
+  y += vector.y;
+  z += vector.z;
+  return (*this);
 }
 
 Vector3D &Vector3D::operator-=(const Vector3D &vector) {
-    x-=vector.x;
-    y-=vector.y;
-    z-=vector.z;
-    return (*this);
+  x -= vector.x;
+  y -= vector.y;
+  z -= vector.z;
+  return (*this);
 }
 
 float &Vector3D::operator[](size_t idx) {
-    if(idx==0) {
-        return x;
-    } else if(idx==1) {
-        return y;
-    } else if(idx==2) {
-        return z;
-    } else {
-        Printf("Vector3D: index %i out of bound\n",idx);
-        return z;
+  if (idx == 0) {
+    return x;
+  } else if (idx == 1) {
+    return y;
+  } else if (idx == 2) {
+    return z;
+  } else {
+    Printf("Vector3D: index %i out of bound\n", idx);
+    return z;
+  }
+}
+
+const float &Vector3D::operator[](size_t idx) const {
+  if (idx == 0) {
+    return x;
+  } else if (idx == 1) {
+    return y;
+  } else if (idx == 2) {
+    return z;
+  } else {
+    Printf("Vector3D: index %i out of bound\n", idx);
+    return z;
+  }
+}
+
+Vector3D CrossProduct(const Vector3D &vectorA, const Vector3D &vectorB) {
+  return Vector3D(vectorA.y * vectorB.z - vectorA.z * vectorB.y,
+                  vectorA.z * vectorB.x - vectorA.x * vectorB.z,
+                  vectorA.x * vectorB.y - vectorA.y * vectorB.x);
+}
+
+float DotProduct(const Vector3D &vectorA, const Vector3D &vectorB) {
+  return vectorA.x * vectorB.x + vectorA.y * vectorB.y + vectorA.z * vectorB.z;
+}
+
+Vector3D operator+(const Vector3D &vectorA, const Vector3D &vectorB) {
+  return Vector3D(vectorA.x + vectorB.x, vectorA.y + vectorB.y,
+                  vectorA.z + vectorB.z);
+}
+
+Vector3D operator-(const Vector3D &vectorA, const Vector3D &vectorB) {
+  return Vector3D(vectorA.x - vectorB.x, vectorA.y - vectorB.y,
+                  vectorA.z - vectorB.z);
+}
+
+Vector3D operator-(const Vector3D &vector) {
+  return Vector3D(-vector.x, -vector.y, -vector.z);
+}
+
+Vector3D operator*(const Vector3D &vectorA, const Vector3D &vectorB) {
+  return Vector3D(vectorA.x * vectorB.x, vectorA.y * vectorB.y,
+                  vectorA.z * vectorB.z);
+}
+
+Vector3D operator*(const Vector3D &vector, float coeff) {
+  return Vector3D(vector.x * coeff, vector.y * coeff, vector.z * coeff);
+}
+
+Vector3D operator*(float coeff, const Vector3D &vector) {
+  return Vector3D(vector.x * coeff, vector.y * coeff, vector.z * coeff);
+}
+
+Vector3D operator/(const Vector3D &vector, float coeff) {
+  if (coeff != 0) {
+    return Vector3D(vector.x / coeff, vector.y / coeff, vector.z / coeff);
+  } else {
+    printf("Vector3D: err divinding by 0\n");
+    return Vector3D(0, 0, 0);
+  }
+}
+
+void Vector3D::RotateX(float value) {
+  float y_tmp;
+  y_tmp = y * cosf(value) - z * sinf(value);
+  z = y * sinf(value) + z * cosf(value);
+  y = y_tmp;
+}
+
+void Vector3D::RotateXDeg(float value) { RotateX(Euler::ToRadian(value)); }
+
+void Vector3D::RotateY(float value) {
+  float x_tmp;
+  x_tmp = x * cosf(value) + z * sinf(value);
+  z = -x * sinf(value) + z * cosf(value);
+  x = x_tmp;
+}
+
+void Vector3D::RotateYDeg(float value) { RotateY(Euler::ToRadian(value)); }
+
+void Vector3D::RotateZ(float value) {
+  float x_tmp;
+  x_tmp = x * cosf(value) - y * sinf(value);
+  y = x * sinf(value) + y * cosf(value);
+  x = x_tmp;
+}
+
+void Vector3D::RotateZDeg(float value) { RotateZ(Euler::ToRadian(value)); }
+
+void Vector3D::Rotate(const RotationMatrix &matrix) {
+  float a[3] = {0, 0, 0};
+  float b[3] = {x, y, z};
+
+  for (int i = 0; i < 3; i++) {
+    for (int j = 0; j < 3; j++) {
+      a[i] += matrix.m[i][j] * b[j];
     }
-}
-
-const float &Vector3D::operator[](size_t idx) const {
-    if(idx==0) {
-        return x;
-    } else if(idx==1) {
-        return y;
-    } else if(idx==2) {
-        return z;
-    } else {
-        Printf("Vector3D: index %i out of bound\n",idx);
-        return z;
-    }
-}
-
-Vector3D CrossProduct(const Vector3D &vectorA,const Vector3D &vectorB) {
-    return Vector3D(vectorA.y*vectorB.z - vectorA.z*vectorB.y,
-                    vectorA.z*vectorB.x - vectorA.x*vectorB.z,
-                    vectorA.x*vectorB.y - vectorA.y*vectorB.x);
-}
-
-float DotProduct(const Vector3D &vectorA,const Vector3D &vectorB) {
-    return vectorA.x*vectorB.x + vectorA.y*vectorB.y+ vectorA.z*vectorB.z;
-}
-
-Vector3D operator+ (const Vector3D &vectorA,const Vector3D &vectorB) {
-    return Vector3D(vectorA.x + vectorB.x,
-                    vectorA.y + vectorB.y,
-                    vectorA.z + vectorB.z);
-}
-
-Vector3D operator- (const Vector3D &vectorA,const Vector3D &vectorB) {
-    return Vector3D(vectorA.x - vectorB.x,
-                    vectorA.y - vectorB.y,
-                    vectorA.z - vectorB.z);
-}
-
-Vector3D operator-(const Vector3D &vector) {
-    return Vector3D(-vector.x,-vector.y,-vector.z);
-}
-
-Vector3D operator * (const Vector3D &vectorA,const Vector3D &vectorB) {
-    return Vector3D(vectorA.x* vectorB.x,
-                    vectorA.y* vectorB.y,
-                    vectorA.z* vectorB.z);
-}
-
-Vector3D operator * (const Vector3D &vector, float coeff) {
-    return Vector3D(vector.x* coeff,
-                    vector.y* coeff,
-                    vector.z* coeff);
-}
-
-Vector3D operator * (float coeff,const Vector3D &vector) {
-    return Vector3D(vector.x* coeff,
-                    vector.y* coeff,
-                    vector.z* coeff);
-}
-
-Vector3D operator/ (const Vector3D &vector, float coeff) {
-    if(coeff!=0) {
-        return Vector3D(vector.x/ coeff,
-                        vector.y/ coeff,
-                        vector.z/ coeff);
-    } else {
-        printf("Vector3D: err divinding by 0\n");
-        return Vector3D(0,0,0);
-    }
-}
-
-void Vector3D::RotateX(float value) {
-    float y_tmp;
-    y_tmp=y*cosf(value)-z*sinf(value);
-    z=y*sinf(value)+z*cosf(value);
-    y=y_tmp;
-}
-
-void Vector3D::RotateXDeg(float value) {
-    RotateX(Euler::ToRadian(value));
-}
-
-void Vector3D::RotateY(float value) {
-    float x_tmp;
-    x_tmp=x*cosf(value)+z*sinf(value);
-    z=-x*sinf(value)+z*cosf(value);
-    x=x_tmp;
-}
-
-void Vector3D::RotateYDeg(float value) {
-    RotateY(Euler::ToRadian(value));
-}
-
-void Vector3D::RotateZ(float value) {
-    float x_tmp;
-    x_tmp=x*cosf(value)-y*sinf(value);
-    y=x*sinf(value)+y*cosf(value);
-    x=x_tmp;
-}
-
-void Vector3D::RotateZDeg(float value) {
-    RotateZ(Euler::ToRadian(value));
-}
-
-void Vector3D::Rotate(const RotationMatrix &matrix) {
-    float a[3]= {0,0,0};
-    float b[3]= {x,y,z};
-
-    for(int i=0; i<3; i++) {
-        for(int j=0; j<3; j++) {
-            a[i]+=matrix.m[i][j]*b[j];
-        }
-    }
-
-    x=a[0];
-    y=a[1];
-    z=a[2];
+  }
+
+  x = a[0];
+  y = a[1];
+  z = a[2];
 }
 
 void Vector3D::Rotate(const Quaternion &quaternion) {
-    RotationMatrix matrix;
-    quaternion.ToRotationMatrix(matrix);
-    Rotate(matrix);
+  RotationMatrix matrix;
+  quaternion.ToRotationMatrix(matrix);
+  Rotate(matrix);
 }
 
 void Vector3D::To2Dxy(Vector2D &vector) const {
-    vector.x=x;
-    vector.y=y;
+  vector.x = x;
+  vector.y = y;
 }
 
 Vector2D Vector3D::To2Dxy(void) const {
-    Vector2D vect;
-    To2Dxy(vect);
-    return vect;
-}
-
-float Vector3D::GetNorm(void) const {
-    return sqrt(x*x+y*y+z*z);
-}
+  Vector2D vect;
+  To2Dxy(vect);
+  return vect;
+}
+
+float Vector3D::GetNorm(void) const { return sqrt(x * x + y * y + z * z); }
 
 void Vector3D::Normalize(void) {
-    float n=GetNorm();
-    if(n!=0) {
-        x=x/n;
-        y=y/n;
-        z=z/n;
-    }
-}
-
-void Vector3D::Saturate(const Vector3D &min,const Vector3D &max) {
-    if(x<min.x) x=min.x;
-    if(x>max.x) x=max.x;
-
-    if(y<min.y) y=min.y;
-    if(y>max.y) y=max.y;
-
-    if(z<min.z) z=min.z;
-    if(z>max.z) z=max.z;
-}
-
-void Vector3D::Saturate(float min,float max) {
-    Saturate(Vector3D(min,min,min),Vector3D(max,max,max));
+  float n = GetNorm();
+  if (n != 0) {
+    x = x / n;
+    y = y / n;
+    z = z / n;
+  }
+}
+
+void Vector3D::Saturate(const Vector3D &min, const Vector3D &max) {
+  if (x < min.x)
+    x = min.x;
+  if (x > max.x)
+    x = max.x;
+
+  if (y < min.y)
+    y = min.y;
+  if (y > max.y)
+    y = max.y;
+
+  if (z < min.z)
+    z = min.z;
+  if (z > max.z)
+    z = max.z;
+}
+
+void Vector3D::Saturate(float min, float max) {
+  Saturate(Vector3D(min, min, min), Vector3D(max, max, max));
 }
 
 void Vector3D::Saturate(const Vector3D &value) {
-    float x=fabs(value.x);
-    float y=fabs(value.y);
-    float z=fabs(value.z);
-    Saturate(Vector3D(-x,-y,-z),Vector3D(x,y,z));
+  float x = fabs(value.x);
+  float y = fabs(value.y);
+  float z = fabs(value.z);
+  Saturate(Vector3D(-x, -y, -z), Vector3D(x, y, z));
 }
 
 void Vector3D::Saturate(float value) {
-    float sat=fabs(value);
-    Saturate(Vector3D(-sat,-sat,-sat),Vector3D(sat,sat,sat));
+  float sat = fabs(value);
+  Saturate(Vector3D(-sat, -sat, -sat), Vector3D(sat, sat, sat));
 }
 
Index: trunk/lib/FlairCore/src/Vector3D.h
===================================================================
--- trunk/lib/FlairCore/src/Vector3D.h	(revision 14)
+++ trunk/lib/FlairCore/src/Vector3D.h	(revision 15)
@@ -16,281 +16,282 @@
 #include <stddef.h>
 
-namespace flair { namespace core {
-    class Vector2D;
-    class RotationMatrix;
-    class Quaternion;
-
-    /*! \class Vector3D
-    *
-    * \brief Class defining a 3D vector
-    */
-    class Vector3D {
-        public:
-            /*!
-            * \brief Constructor
-            *
-            * Construct a Vector3D using specified values.
-            *
-            * \param x
-            * \param y
-            * \param z
-            */
-            Vector3D(float x=0,float y=0,float z=0);
-
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~Vector3D();
-
-            /*!
-            * \brief x
-            */
-            float x;
-
-            /*!
-            * \brief y
-            */
-            float y;
-
-            /*!
-            * \brief z
-            */
-            float z;
-
-            /*!
-            * \brief x axis rotation
-            *
-            * \param value rotation value in radians
-            */
-            void RotateX(float value);
-
-            /*!
-            * \brief x axis rotation
-            *
-            * \param value rotation value in degrees
-            */
-            void RotateXDeg(float value);
-
-            /*!
-            * \brief y axis rotation
-            *
-            * \param value rotation value in radians
-            */
-            void RotateY(float value);
-
-            /*!
-            * \brief y axis rotation
-            *
-            * \param value rotation value in degrees
-            */
-            void RotateYDeg(float value);
-
-            /*!
-            * \brief z axis rotation
-            *
-            * \param value rotation value in radians
-            */
-            void RotateZ(float value);
-
-            /*!
-            * \brief z axis rotation
-            *
-            * \param value rotation value in degrees
-            */
-            void RotateZDeg(float value);
-
-            /*!
-            * \brief rotation
-            *
-            * \param matrix rotation matrix
-            */
-            void Rotate(const RotationMatrix &matrix);
-
-            /*!
-            * \brief rotation
-            *
-            * Compute a rotation from a quaternion. This method uses a rotation matrix
-            * internaly.
-            *
-            * \param quaternion quaternion
-            */
-            void Rotate(const Quaternion &quaternion);
-
-            /*!
-            * \brief Convert to a Vector2D
-            *
-            * Uses x and y coordinates.
-            *
-            * \param vector destination
-            */
-            void To2Dxy(Vector2D &vector) const;
-
-            /*!
-            * \brief Convert to a Vector2D
-            *
-            * Uses x and y coordinates.
-            *
-            * \return destination
-            */
-            Vector2D To2Dxy(void) const;
-
-            /*!
-            * \brief Norm
-            *
-            * \return value
-            */
-            float GetNorm(void) const;
-
-            /*!
-            * \brief Normalize
-            */
-            void Normalize(void);
-
-            /*!
-            * \brief Saturate
-            *
-            * Saturate between min and max
-            *
-            * \param min minimum value
-            * \param max maximum value
-            */
-            void Saturate(const Vector3D &min,const Vector3D &max);
-
-            /*!
-            * \brief Saturate
-            *
-            * Saturate between min and max
-            *
-            * \param min minimum Vector3D(min,min,min) value
-            * \param max maximum Vector3D(max,max,max) value
-            */
-            void Saturate(float min,float max);
-
-            /*!
-            * \brief Saturate
-            *
-            * Saturate between -abs(value) and abs(value)
-            *
-            * \param value saturation Vector3D value
-            */
-            void Saturate(const Vector3D &value);
-
-            /*!
-            * \brief Saturate
-            *
-            * Saturate between -abs(Vector3D(value,value,value)) and abs(Vector3D(value,value,value))
-            *
-            * \param value saturation Vector3D(value,value,value)
-            */
-            void Saturate(float value);
-
-            float &operator[](size_t idx);
-            const float &operator[](size_t idx) const;
-            Vector3D &operator=(const Vector3D& vector);
-            Vector3D &operator+=(const Vector3D& vector);
-            Vector3D &operator-=(const Vector3D& vector);
-
-        private:
-
-    };
-
-    /*! Add
-    *
-    * \brief Add
-    *
-    * \param vectorA vector
-    * \param vectorB vector
-    *
-    * \return vectorA+vectorB
-    */
-    Vector3D operator + (const Vector3D &vectorA,const Vector3D &vectorB);
-
-    /*! Substract
-    *
-    * \brief Substract
-    *
-    * \param vectorA vector
-    * \param vectorB vector
-    *
-    * \return vectorA-vectorB
-    */
-    Vector3D operator - (const Vector3D &vectorA,const Vector3D &vectorB);
-
-    /*! Minus
-    *
-    * \brief Minus
-    *
-    * \param vector vector
-    *
-    * \return -vector
-    */
-    Vector3D operator-(const Vector3D &vector);
-
-    /*! Divid
-    *
-    * \brief Divid
-    *
-    * \param vector vector
-    * \param coeff coefficent
-    *
-    * \return vector/coefficient
-    */
-    Vector3D operator / (const Vector3D &vector, float coeff);
-
-    /*! Hadamard product
-    *
-    * \brief Hadamard product
-    *
-    * \param vectorA vector
-    * \param vectorBA vector
-    *
-    * \return Hadamard product
-    */
-    Vector3D operator * (const Vector3D &vectorA, const Vector3D &vectorB);
-
-    /*! Multiply
-    *
-    * \brief Multiply
-    *
-    * \param vector vector
-    * \param coeff coefficent
-    *
-    * \return coefficient*vector
-    */
-    Vector3D operator * (const Vector3D &vector, float coeff);
-
-    /*! Multiply
-    *
-    * \brief Multiply
-    *
-    * \param coeff coefficent
-    * \param vector vector
-    *
-    * \return coefficient*vector
-    */
-    Vector3D operator * (float coeff, const Vector3D &vector);
-
-    /*! Cross product
-    *
-    * \brief Cross product
-    *
-    * \param vectorA first vector
-    * \param vectorB second vector
-    *
-    * \return cross product
-    */
-    Vector3D CrossProduct(const Vector3D &vectorA, const Vector3D &vectorB);
-
-    /*! Dot product
-    *
-    * \brief Dot product
-    *
-    * \param vectorA first vector
-    * \param vectorB second vector
-    *
-    * \return dot product
-    */
-    float DotProduct(const Vector3D &vectorA, const Vector3D &vectorB);
+namespace flair {
+namespace core {
+class Vector2D;
+class RotationMatrix;
+class Quaternion;
+
+/*! \class Vector3D
+*
+* \brief Class defining a 3D vector
+*/
+class Vector3D {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a Vector3D using specified values.
+  *
+  * \param x
+  * \param y
+  * \param z
+  */
+  Vector3D(float x = 0, float y = 0, float z = 0);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~Vector3D();
+
+  /*!
+  * \brief x
+  */
+  float x;
+
+  /*!
+  * \brief y
+  */
+  float y;
+
+  /*!
+  * \brief z
+  */
+  float z;
+
+  /*!
+  * \brief x axis rotation
+  *
+  * \param value rotation value in radians
+  */
+  void RotateX(float value);
+
+  /*!
+  * \brief x axis rotation
+  *
+  * \param value rotation value in degrees
+  */
+  void RotateXDeg(float value);
+
+  /*!
+  * \brief y axis rotation
+  *
+  * \param value rotation value in radians
+  */
+  void RotateY(float value);
+
+  /*!
+  * \brief y axis rotation
+  *
+  * \param value rotation value in degrees
+  */
+  void RotateYDeg(float value);
+
+  /*!
+  * \brief z axis rotation
+  *
+  * \param value rotation value in radians
+  */
+  void RotateZ(float value);
+
+  /*!
+  * \brief z axis rotation
+  *
+  * \param value rotation value in degrees
+  */
+  void RotateZDeg(float value);
+
+  /*!
+  * \brief rotation
+  *
+  * \param matrix rotation matrix
+  */
+  void Rotate(const RotationMatrix &matrix);
+
+  /*!
+  * \brief rotation
+  *
+  * Compute a rotation from a quaternion. This method uses a rotation matrix
+  * internaly.
+  *
+  * \param quaternion quaternion
+  */
+  void Rotate(const Quaternion &quaternion);
+
+  /*!
+  * \brief Convert to a Vector2D
+  *
+  * Uses x and y coordinates.
+  *
+  * \param vector destination
+  */
+  void To2Dxy(Vector2D &vector) const;
+
+  /*!
+  * \brief Convert to a Vector2D
+  *
+  * Uses x and y coordinates.
+  *
+  * \return destination
+  */
+  Vector2D To2Dxy(void) const;
+
+  /*!
+  * \brief Norm
+  *
+  * \return value
+  */
+  float GetNorm(void) const;
+
+  /*!
+  * \brief Normalize
+  */
+  void Normalize(void);
+
+  /*!
+  * \brief Saturate
+  *
+  * Saturate between min and max
+  *
+  * \param min minimum value
+  * \param max maximum value
+  */
+  void Saturate(const Vector3D &min, const Vector3D &max);
+
+  /*!
+  * \brief Saturate
+  *
+  * Saturate between min and max
+  *
+  * \param min minimum Vector3D(min,min,min) value
+  * \param max maximum Vector3D(max,max,max) value
+  */
+  void Saturate(float min, float max);
+
+  /*!
+  * \brief Saturate
+  *
+  * Saturate between -abs(value) and abs(value)
+  *
+  * \param value saturation Vector3D value
+  */
+  void Saturate(const Vector3D &value);
+
+  /*!
+  * \brief Saturate
+  *
+  * Saturate between -abs(Vector3D(value,value,value)) and
+  *abs(Vector3D(value,value,value))
+  *
+  * \param value saturation Vector3D(value,value,value)
+  */
+  void Saturate(float value);
+
+  float &operator[](size_t idx);
+  const float &operator[](size_t idx) const;
+  Vector3D &operator=(const Vector3D &vector);
+  Vector3D &operator+=(const Vector3D &vector);
+  Vector3D &operator-=(const Vector3D &vector);
+
+private:
+};
+
+/*! Add
+*
+* \brief Add
+*
+* \param vectorA vector
+* \param vectorB vector
+*
+* \return vectorA+vectorB
+*/
+Vector3D operator+(const Vector3D &vectorA, const Vector3D &vectorB);
+
+/*! Substract
+*
+* \brief Substract
+*
+* \param vectorA vector
+* \param vectorB vector
+*
+* \return vectorA-vectorB
+*/
+Vector3D operator-(const Vector3D &vectorA, const Vector3D &vectorB);
+
+/*! Minus
+*
+* \brief Minus
+*
+* \param vector vector
+*
+* \return -vector
+*/
+Vector3D operator-(const Vector3D &vector);
+
+/*! Divid
+*
+* \brief Divid
+*
+* \param vector vector
+* \param coeff coefficent
+*
+* \return vector/coefficient
+*/
+Vector3D operator/(const Vector3D &vector, float coeff);
+
+/*! Hadamard product
+*
+* \brief Hadamard product
+*
+* \param vectorA vector
+* \param vectorBA vector
+*
+* \return Hadamard product
+*/
+Vector3D operator*(const Vector3D &vectorA, const Vector3D &vectorB);
+
+/*! Multiply
+*
+* \brief Multiply
+*
+* \param vector vector
+* \param coeff coefficent
+*
+* \return coefficient*vector
+*/
+Vector3D operator*(const Vector3D &vector, float coeff);
+
+/*! Multiply
+*
+* \brief Multiply
+*
+* \param coeff coefficent
+* \param vector vector
+*
+* \return coefficient*vector
+*/
+Vector3D operator*(float coeff, const Vector3D &vector);
+
+/*! Cross product
+*
+* \brief Cross product
+*
+* \param vectorA first vector
+* \param vectorB second vector
+*
+* \return cross product
+*/
+Vector3D CrossProduct(const Vector3D &vectorA, const Vector3D &vectorB);
+
+/*! Dot product
+*
+* \brief Dot product
+*
+* \param vectorA first vector
+* \param vectorB second vector
+*
+* \return dot product
+*/
+float DotProduct(const Vector3D &vectorA, const Vector3D &vectorB);
 
 } // end namespace core
Index: trunk/lib/FlairCore/src/Vector3DSpinBox.cpp
===================================================================
--- trunk/lib/FlairCore/src/Vector3DSpinBox.cpp	(revision 14)
+++ trunk/lib/FlairCore/src/Vector3DSpinBox.cpp	(revision 15)
@@ -11,5 +11,6 @@
 //  version:    $Id: $
 //
-//  purpose:    Class displaying 3 QDoubleSpinBox for x,y,z on the ground station
+//  purpose:    Class displaying 3 QDoubleSpinBox for x,y,z on the ground
+//  station
 //
 //
@@ -20,28 +21,30 @@
 using std::string;
 
-namespace flair { namespace gui {
+namespace flair {
+namespace gui {
 
-Vector3DSpinBox::Vector3DSpinBox(const LayoutPosition* position,string name,double min,double max,double step,int decimals,core::Vector3D default_value):Box(position,name,"Vector3DSpinBox") {
-    //update value from xml file
-    default_value.Saturate(min,max);
-    box_value=default_value;
+Vector3DSpinBox::Vector3DSpinBox(const LayoutPosition *position, string name,
+                                 double min, double max, double step,
+                                 int decimals, core::Vector3D default_value)
+    : Box(position, name, "Vector3DSpinBox") {
+  // update value from xml file
+  default_value.Saturate(min, max);
+  box_value = default_value;
 
-    SetVolatileXmlProp("min",min);
-    SetVolatileXmlProp("max",max);
-    SetVolatileXmlProp("step",step);
-    SetVolatileXmlProp("decimals",decimals);
-    GetPersistentXmlProp("value_x",box_value.x);
-    SetPersistentXmlProp("value_x",box_value.x);
-    GetPersistentXmlProp("value_y",box_value.y);
-    SetPersistentXmlProp("value_y",box_value.y);
-    GetPersistentXmlProp("value_z",box_value.z);
-    SetPersistentXmlProp("value_z",box_value.z);
+  SetVolatileXmlProp("min", min);
+  SetVolatileXmlProp("max", max);
+  SetVolatileXmlProp("step", step);
+  SetVolatileXmlProp("decimals", decimals);
+  GetPersistentXmlProp("value_x", box_value.x);
+  SetPersistentXmlProp("value_x", box_value.x);
+  GetPersistentXmlProp("value_y", box_value.y);
+  SetPersistentXmlProp("value_y", box_value.y);
+  GetPersistentXmlProp("value_z", box_value.z);
+  SetPersistentXmlProp("value_z", box_value.z);
 
-    SendXml();
+  SendXml();
 }
 
-Vector3DSpinBox::~Vector3DSpinBox() {
-
-}
+Vector3DSpinBox::~Vector3DSpinBox() {}
 /*
 Vector3DSpinBox::operator core::Vector3D() const {
@@ -50,21 +53,25 @@
 */
 core::Vector3D Vector3DSpinBox::Value(void) const {
-    core::Vector3D tmp;
+  core::Vector3D tmp;
 
-    GetMutex();
-    tmp=box_value;
-    ReleaseMutex();
+  GetMutex();
+  tmp = box_value;
+  ReleaseMutex();
 
-    return tmp;
+  return tmp;
 }
 
 void Vector3DSpinBox::XmlEvent(void) {
-    bool changed=false;
-    GetMutex();
-    if(GetPersistentXmlProp("value_x",box_value.x)) changed=true;
-    if(GetPersistentXmlProp("value_y",box_value.y)) changed=true;
-    if(GetPersistentXmlProp("value_z",box_value.z)) changed=true;
-    if(changed) SetValueChanged();
-    ReleaseMutex();
+  bool changed = false;
+  GetMutex();
+  if (GetPersistentXmlProp("value_x", box_value.x))
+    changed = true;
+  if (GetPersistentXmlProp("value_y", box_value.y))
+    changed = true;
+  if (GetPersistentXmlProp("value_z", box_value.z))
+    changed = true;
+  if (changed)
+    SetValueChanged();
+  ReleaseMutex();
 }
 
